#!/usr/bin/python
# -*- coding: utf-8 -*-

####zhucheng
import xlsxwriter
import tempfile
from app.models import AttendanceCalendar
from app.common.view_helper import _build_query


@subject_blueprint.route('/subject/common_export/subject.zip', methods=['GET'])
# @login_required
def subject_common_export():
    params = request.form or request.get_json() or request.args
    def iterable(url, cdn):
        try:
            with open(cdn.get_path(url)) as f:
                yield f.read()
        except:
            yield ''

    def generator(subjects):
        z = zipstream.ZipFile(mode='w', compression=zipstream.ZIP_DEFLATED)
        for i, subject in enumerate(query):
            logger.info("query is %s", subject.get_json())
            row_index = i + 1
            name = subject.name
            job_number = subject.job_number
            department = subject.department
            title = subject.title
            phone = subject.phone
            email = subject.email
            remark = subject.remark
            description = subject.description
            for photo in subject.photos:
                if photo.origin_url:
                    url = photo.origin_url
                    cdn = oss
                else:
                    url = photo.url
                    cdn = storage
                avatar = subject.avatar
                dir_name = url.split('/')[-2]
                file_name = url.split('/')[-1]
                short_path = os.path.join('/', dir_name, name+ '.' + file_name.split('.')[-1])
                z.write_iter(short_path, iterable(url, cdn))
                if avatar:
                    # avatar_path = os.path.join('/', url.split('/')[-2], name)
                    dir_name = url.split('/')[-2]
                    file_name = url.split('/')[-1]
                    avatar_path = os.path.join('/', dir_name, name + '.' + file_name.split('.')[-1])
                    logger.info("avatar_path is %s", avatar_path)
                    z.write_iter(avatar_path, iterable(avatar, storage))

            worksheet.write(row_index, 0, name)
            worksheet.write(row_index, 1, job_number)
            worksheet.write(row_index, 2, department)
            worksheet.write(row_index, 3, title)
            worksheet.write(row_index, 4, phone)
            worksheet.write(row_index, 5, email)
            worksheet.write(row_index, 6, remark)
            worksheet.write(row_index, 7, description)

        workbook.close()

        z.writestr("subject.xlsx", temp.read())

        for zip_data in z:
            yield zip_data

    query =  g.user.company.subjects.filter(Subject.subject_type == params.get('subject_type',0)) \
        .options(db.eagerload_all(Subject.photos))
    name = params.get('name')
    if name:
        name = name.replace('\\', '\\\\')
        query = query.filter(Subject.real_name.contains(name) | Subject.pinyin.contains(name))

    temp = tempfile.TemporaryFile()
    workbook = xlsxwriter.Workbook(temp)
    worksheet = workbook.add_worksheet("subject")

    worksheet.write(0, 0, u'姓名')
    worksheet.write(0, 1, u'工号')
    worksheet.write(0, 2, u'部门')
    worksheet.write(0, 3, u'职位')
    worksheet.write(0, 4, u'电话')
    worksheet.write(0, 5, u'邮箱')
    worksheet.write(0, 6, u'签名')
    worksheet.write(0, 7, u'备注')

    # if subjects is None:subjects=[]
    # response = Response(generator(query), mimetype='application/zip')
    # response.headers['Content-Disposition'] = 'attachment; filename={}'.format('export.zip')
    # return response
    #return send_file(sio, mimetype='application/octet-stream', attachment_filename=export_name)
    response = Response(generator(query), mimetype='application/zip')
    response.headers['Content-Disposition'] = 'attachment; filename={}'.format('export.zip')
    return  response


